#include <Client.h>
#include <Ethernet.h>
#include <stdio.h>
#include <XBee.h>

#define TIEMPO_ESPERA 5000
#define TIEMPO_ESPERA2 1200000

// creas el objeto servidor, dando el lugar de IP del servidor y la puerta 

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xAD };
byte arduinoip[] = { 192, 168, 0, 116 };
byte ip[] = { 192, 168, 0, 100 };
Client client(ip,9999); //decimos que trabaje como client

// Aqui creamos los paquetes de Xbee
XBee xbee = XBee();

void setup() {
 Ethernet.begin(mac,arduinoip); // le damos una ip al arduino
  xbee.begin(9600);
   if (client.connect()){  // Conectando
  }
}

void loop() {
    XBeeResponse response = XBeeResponse();
    Rx16Response rx16 = Rx16Response();
    uint8_t* data;
    //leemos los paquetes de que esta enviando el arduino de escritura
    while(!xbee.getResponse().isAvailable()){
    xbee.readPacket();
    }
    // si el modulo xbee ha escuchado bien pasa a comprobar si el paquete es como el enviado
    if (xbee.getResponse().isAvailable()) {
      // De este if pasa, no pasa del siguiente
      if (xbee.getResponse().getApiId() == RX_16_RESPONSE) {
		// si lo es obtiene la informacion
          xbee.getResponse().getRx16Response(rx16);
          //da la senyal de confirmacion del paquete
             
   if(client.connected()){
     if(client.available()){
        int i = 0;
        char buf[255] = {}, c;
        while ((c = client.read()) != -1) {
           buf[i++] = c;
           if (i == sizeof(buf)){
             break;
           }
        }
        // el servidor hace el envio de confirmacion de conexion y lo comprueba
        if(strcmp(buf, "GET /xml-arduino/protocol HTTP/1.1\nHost: localhost\n") == 0){
            
		// efectuamos el paquete que hay que enviar al servidor
          char buf[1024];
          sprintf(buf, "HTTP/1.1 200 OK\n"
                    "Content-Type: text/plain;charset=UTF-8\n"
                    "Content-Length: 49\n\n"
                    "<xml><entry><sensor>%d</sensor><humedity>%d</humedity><temperature>%d</temperature><latitud>%d%d%d.%d%d %d</latitud><longitud>%d%d%d.%d%d %d</longitud></entry></xml>", rx16.getData(0), rx16.getData(1), rx16.getData(2), rx16.getData(3), rx16.getData(4), rx16.getData(5),rx16.getData(6), rx16.getData(7), rx16.getData(8), rx16.getData(9), rx16.getData(10), rx16.getData(11), rx16.getData(12),rx16.getData(13),rx16.getData(14));
          client.print(buf);
        }
        delay(TIEMPO_ESPERA2);
     }
     delay(TIEMPO_ESPERA);
   } else {
      client.stop();
      if (client.connect()){
      }else{
      delay(2000);
      }
    }  
  }
 }
}
